#include <iostream>
using namespace std;
#include<string>
#include<cmath>
#include<algorithm>



int main(int argc, char** argv)
 {
 	ios_base::sync_with_stdio(false);
cin.tie(NULL); 

   int n;
   cin>>n;
   int O,A,B,AB;
   cin>>O>>A>>B>>AB;
   int o,a,b,ab;
   string s[n];
   int v[n];
   int ispisaa[n];
   int ispisan[n];
   
   int ispisbb[n];
   int ispisbn[n];
   
   int ispisnn[n];
   
   int ispisaba[n];
   int ispisabb[n];
   int ispisabn[n];
   int ispisabab[n];
   
   int broja=0;
   int brojb=0;
   int brojn=0;
   int brojab=0;
   for(int i=0;i<n;i++)
   {
   	  ispisaa[i]=0;
   	  ispisan[i]=0;
   	  ispisbb[i]=0;
   	  ispisbn[i]=0;
   	  ispisnn[i]=0;
   	  ispisaba[i]=0;
   	  ispisabb[i]=0;
   	  ispisabn[i]=0;
   	  ispisabab[i]=0;
   }
   	  
   
  for(int i=0;i<n;i++)
  {
  	cin>>s[i];
  	cin>>v[i];
  }
  
  int abrojac=0;
  int bbrojac=0;
  
  for(int i=0;i<n;i++)
  {
  	if(s[i]=="A")
	  {
	  	abrojac+=v[i];
	  }
	  
	  if(s[i]=="B")
	  {
	  	bbrojac+=v[i];
	  }
  }
  
  abrojac=A-abrojac;
  bbrojac=B-bbrojac;
  
  for(int i=0;i<n;i++)
  {
  	
  	if(s[i]=="A")
	  {
	  	if(A>0)
	  	{
	  		int p=A-v[i];
	  	if(p>-1)
		  {
		  	ispisaa[broja]=v[i];
		  	A=p;
		  	v[i]=0;
		  }
	       
		  else
		  {
		  	ispisaa[broja]=A;
		  	v[i]=v[i]-A;
		  }
	}
		  	if(O>0&&v[i]>0)
			  {
			  	
			  int p=O-v[i];
			  	if(p>-1)
				  {
				  	ispisan[broja]=v[i];
				  	O=p;
				  	v[i]=0;
				  }
				  else
				  {
				  	ispisan[broja]=O;
				  	v[i]=v[i]-O;
				  }
			  	
			  }
		  	
		  	
		  
		  
		  broja++;
	}
	
	if(s[i]=="B")
	{
	
		  	if(B>0)
	  	{
	  		int p=B-v[i];
	  	if(p>-1)
		  {
		  	ispisbb[brojb]=v[i];
		  	B=p;
		  	v[i]=0;
		  }
		  else
		  {
		  	ispisbb[brojb]=B;
		  	v[i]=v[i]-B;
		  }
	}
		  	if(O>0&&v[i]>0)
			  {
			  	
			  	int p=O-v[i];
			  	if(p>-1)
				  {
				  	ispisbn[brojb]=v[i];
				  	O=p;
				  	v[i]=0;
				  }
				  else
				  {
				  	ispisbn[brojb]=O;
				  	v[i]=v[i]-O;
				  }
			  	
			  }
		  	
		  	
		  
		  
		  
		  
	  	
	  brojb++;	
	  }
	  
	  if(s[i]=="O")
	  {
	  if(O>0)
	  	{
	  		int p=O-v[i];
	  	if(p>-1)
		  {
		  	ispisnn[brojn]=v[i];
		  	O=p;
		  	v[i]=0;
		  }
		  else
		  {
		  	ispisnn[brojn]=O;
		  	v[i]=v[i]-O;
		  }
	}
	
	brojn++;
	  }
	  
	  if(s[i]=="AB")
	  {
	  	
	  	if(AB>0)
	  	{
	  		int p=AB-v[i];
	  	if(p>-1)
		  {
		  	ispisabab[brojab]=v[i];
		  	AB=p;
		  	v[i]=0;
		  }
		  else
		  {
		  	ispisabab[brojab]=AB;
		  	v[i]=v[i]-AB;
		  }
	}
	
	if(abrojac>bbrojac)
	{
		if(A>0&&v[i]>0)
	  	{
	  		int p=A-v[i];
	  	if(p>-1)
		  {
		  	ispisaba[brojab]=v[i];
		  	A=p;
		  	v[i]=0;
		  }
		  else
		  {
		  	ispisaba[brojab]=A;
		  	v[i]=v[i]-A;
		  }
	}
	
	if(B>0&&v[i]>0)
	  	{
	  		int p=B-v[i];
	  	if(p>-1)
		  {
		  	ispisabb[brojab]=v[i];
		  	B=p;
		  	v[i]=0;
		  }
		  else
		  {
		  	ispisabb[brojab]=B;
		  	v[i]=v[i]-B;
		  }
	}
	}
	
	else
	{
		if(B>0&&v[i]>0)
	  	{
	  		int p=B-v[i];
	  	if(p>-1)
		  {
		  	ispisabb[brojab]=v[i];
		  	B=p;
		  	v[i]=0;
		  }
		  else
		  {
		  	ispisabb[brojab]=B;
		  	v[i]=v[i]-B;
		  }
	}
	
	if(A>0&&v[i]>0)
	  	{
	  		int p=A-v[i];
	  	if(p>-1)
		  {
		  	ispisaba[brojab]=v[i];
		  	A=p;
		  	v[i]=0;
		  }
		  else
		  {
		  	ispisaba[brojab]=A;
		  	v[i]=v[i]-A;
		  }
	}
	}
	
	
	
	if(O>0&&v[i]>0)
	  	{
	  		int p=O-v[i];
	  	if(p>-1)
		  {
		  	ispisabn[brojab]=v[i];
		  	O=p;
		  	v[i]=0;
		  }
		  else
		  {
		  	ispisabn[brojab]=O;
		  	v[i]=v[i]-O;
		  }
	}
	
	
	  	
	  	
	  	brojab++;
	  }
	 	
	  	
	  
	  
	 
  	
  	
  }
  int provera=0;
  for(int i=0;i<n;i++)
  {
  	if(v[i]!=0)
  	provera++;
  }
  
  if(provera!=0)
  {
  	cout<<"nemoguce";
  }
  else
  {
  	cout<<"moguce"<<endl;
  	int ba=0;
  	int bb=0;
  	int bc=0;
  	int bn=0;
  	for(int i=0;i<n;i++)
	  {
	  	if(s[i]=="A")
		  {
		  	cout<<ispisan[ba]<<" "<<ispisaa[ba]<<" "<<0<<" "<<0;
		  	ba++;
		  }
		  
		  
		  if(s[i]=="B")
		  {
		  	cout<<ispisbn[bb]<<" "<<0<<" "<<ispisbb[bb]<<" "<<0;
		  	bb++;
		  }
		  
		  if(s[i]=="AB")
		  {
		  	cout<<ispisabn[bc]<<" "<<ispisaba[bc]<<" "<<ispisabb[bc]<<" "<<ispisabab[bc];
		  	bc++;
		  }
		  
		  if(s[i]=="O")
		  {
		  	cout<<ispisnn[bn]<<" "<<0<<" "<<0<<" "<<0;
		  	bn++;
		  }
		  
		  if(i+1<n)
		  cout<<endl;
		  
		  
		  
	  }
  }
  
   
  
}